gtkmm: Gtk::ComboBoxText Class Reference

gtkmm 3.6.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions
Gtk::ComboBoxText Class Reference
Widgets

This is a simple variant of ComboBox that hides the model-view complexity for simple text-only use cases. More...

Inheritance diagram for Gtk::ComboBoxText:
[legend]

List of all members.

## Public Member Functions
virtual | ~ComboBoxText ()
GtkComboBoxText* | gobj ()
| Provides access to the underlying C GtkObject.
const GtkComboBoxText* | gobj () const
| Provides access to the underlying C GtkObject.
| ComboBoxText (bool has_entry=false)
| Creates a new empty ComboBoxText, optionally with an entry.
void | append (const Glib::ustring& text)
| Appends text to the list of strings stored in combo_box.
void | append (const Glib::ustring& id, const Glib::ustring& text)
| Appends text to the list of strings stored in combo_box.
void | insert (int position, const Glib::ustring& text)
| Inserts text at position in the list of strings stored in combo_box.
void | insert (int position, const Glib::ustring& id, const Glib::ustring& text)
| Inserts text at position in the list of strings stored in combo_box.
void | prepend (const Glib::ustring& text)
| Prepends text to the list of strings stored in combo_box.
void | prepend (const Glib::ustring& id, const Glib::ustring& text)
| Prepends text to the list of strings stored in combo_box.
void | remove_text (int position)
| Removes the string at position from combo_box.
Glib::ustring | get_active_text () const
| Returns the currently active string in combo_box, or `0` if none is selected.
void | remove_all ()
| Removes all the text entries from the combo box.
void | set_active_text (const Glib::ustring& text)
Public Member Functions inherited from Gtk::ComboBox
virtual | ~ComboBox ()
| ComboBox (bool has_entry=false)
| Creates a new empty #GtkComboBox, optionally with an entry.
| ComboBox (const Glib::RefPtr< TreeModel >& model, bool has_entry=false)
| Creates a new ComboBox with the model initialized to model.
| ComboBox (const Glib::RefPtr< CellArea >& cell_area, bool has_entry=false)
| Creates a new empty #GtkComboBox, optionally with an entry.
void | set_wrap_width (int width)
| Sets the wrap width of combo_box to be width.
int | get_wrap_width () const
| Returns the wrap width which is used to determine the number of columns for the popup menu.
void | set_row_span_column (int row_span)
| Sets the column with row span information for combo_box to be row_span.
int | get_row_span_column () const
| Returns the column with row span information for combo_box.
void | set_column_span_column (int column_span)
| Sets the column with column span information for combo_box to be column_span.
int | get_column_span_column () const
| Returns the column with column span information for combo_box.
bool | get_add_tearoffs () const
| Gets the current value of the :add-tearoffs property.
void | set_add_tearoffs (bool add_tearoffs=true)
| Sets whether the popup menu should have a tearoff menu item.
Glib::ustring | get_title () const
| Gets the current title of the menu in tearoff mode.
void | set_title (const Glib::ustring& title)
| Sets the menu's title in tearoff mode.
bool | get_focus_on_click () const
| Returns whether the combo box grabs focus when it is clicked with the mouse.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the combo box will grab focus when it is clicked with the mouse.
int | get_active_row_number () const
| Returns the index of the currently active item, or -1 if there's no active item.
TreeModel::iterator | get_active ()
| Gets an iterator that points to the current active item, if it exists.
TreeModel::const_iterator | get_active () const
| Gets an iterator that points to the current active item, if it exists.
void | set_active (int index)
| Sets the active item of combo_box to be the item at index.
void | set_active (const TreeModel::iterator& iter)
| Sets the current active item to be the one referenced by iter, or unsets the active item if iter is `0`.
Glib::ustring | get_entry_text () const
| Get the text in the entry, if there is an entry.
void | unset_active ()
| Causes no item to be active.
Glib::RefPtr< TreeModel > | get_model ()
| Returns the Gtk::TreeModel which is acting as data source for combo_box.
Glib::RefPtr< const TreeModel > | get_model () const
| Returns the Gtk::TreeModel which is acting as data source for combo_box.
void | set_model (const Glib::RefPtr< TreeModel >& model)
| Sets the model used by combo_box to be model.
void | unset_model ()
| Remove the model from the ComboBox.
void | set_row_separator_func (const SlotRowSeparator& slot)
| Sets the row separator function, which is used to determine whether a row should be drawn as a separator.
void | unset_row_separator_func ()
| Causes no separators to be drawn.
void | set_button_sensitivity (SensitivityType sensitivity)
| Sets whether the dropdown button of the combo box should be always sensitive (Gtk::SENSITIVITY_ON), never sensitive (Gtk::SENSITIVITY_OFF) or only if there is at least one item to display (Gtk::SENSITIVITY_AUTO).
SensitivityType | get_button_sensitivity () const
| Returns whether the combo box sets the dropdown button sensitive or not when there are no items in the model.
bool | get_has_entry () const
| Returns whether the combo box has an entry.
void | set_entry_text_column (const TreeModelColumnBase& text_column) const
| Sets the model column which combo_box should use to get strings from to be text_column.
void | set_entry_text_column (int text_column)
| Sets the model column which combo_box should use to get strings from to be text_column.
int | get_entry_text_column () const
| Returns the column which combo_box is using to get the strings from to display in the internal entry.
void | set_popup_fixed_width (bool fixed=true)
| Specifies whether the popup's width should be a fixed width matching the allocated width of the combo box.
bool | get_popup_fixed_width () const
| Gets whether the popup uses a fixed width matching the allocated width of the combo box.
void | popup ()
| Pops up the menu or dropdown list of combo_box.
void | popup (const Glib::RefPtr< Gdk::Device >& device)
| Pops up the menu or dropdown list of combo_box, the popup window will be grabbed so only device and its associated pointer/keyboard are the only Gdk::Devices able to send events to it.
void | popdown ()
| Hides the menu or dropdown list of combo_box.
Glib::RefPtr< Atk::Object > | get_popup_accessible ()
| Gets the accessible object corresponding to the combo box's popup.
Glib::RefPtr< const Atk::Object > | get_popup_accessible () const
| Gets the accessible object corresponding to the combo box's popup.
int | get_id_column () const
| Returns the column which combo_box is using to get string IDs for values from.
void | set_id_column (int id_column)
| Sets the model column which combo_box should use to get string IDs for values from.
Glib::ustring | get_active_id () const
| Returns the ID of the active row of combo_box.
void | get_active_id (const Glib::ustring& active_id)
| Changes the active row of combo_box to the one that has an ID equal to active_id, or unsets the active row if active_id is `0`.
bool | set_active_id (const Glib::ustring& active_id)
| Changes the active row of the combo box to the one that has an ID equal to active_id.
Entry* | get_entry ()
const Entry* | get_entry () const
Glib::PropertyProxy < Glib::RefPtr< TreeModel > > | property_model ()
| The model for the combo box.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< TreeModel > > | property_model () const
| The model for the combo box.
Glib::PropertyProxy< int > | property_wrap_width ()
| Wrap width for laying out the items in a grid.
Glib::PropertyProxy_ReadOnly< int > | property_wrap_width () const
| Wrap width for laying out the items in a grid.
Glib::PropertyProxy< int > | property_row_span_column ()
| TreeModel column containing the row span values.
Glib::PropertyProxy_ReadOnly< int > | property_row_span_column () const
| TreeModel column containing the row span values.
Glib::PropertyProxy< int > | property_column_span_column ()
| TreeModel column containing the column span values.
Glib::PropertyProxy_ReadOnly< int > | property_column_span_column () const
| TreeModel column containing the column span values.
Glib::PropertyProxy< int > | property_active ()
| The item which is currently active.
Glib::PropertyProxy_ReadOnly< int > | property_active () const
| The item which is currently active.
Glib::PropertyProxy< bool > | property_add_tearoffs ()
| Whether dropdowns should have a tearoff menu item.
Glib::PropertyProxy_ReadOnly < bool > | property_add_tearoffs () const
| Whether dropdowns should have a tearoff menu item.
Glib::PropertyProxy< bool > | property_has_frame ()
| Whether the combo box draws a frame around the child.
Glib::PropertyProxy_ReadOnly < bool > | property_has_frame () const
| Whether the combo box draws a frame around the child.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the combo box grabs focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly < bool > | property_focus_on_click () const
| Whether the combo box grabs focus when it is clicked with the mouse.
Glib::PropertyProxy < Glib::ustring > | property_tearoff_title ()
| A title that may be displayed by the window manager when the popup is torn-off.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tearoff_title () const
| A title that may be displayed by the window manager when the popup is torn-off.
Glib::PropertyProxy_ReadOnly < bool > | property_popup_shown () const
| Whether the combo's dropdown is shown.
Glib::PropertyProxy < SensitivityType > | property_button_sensitivity ()
| Whether the dropdown button is sensitive when the model is empty.
Glib::PropertyProxy_ReadOnly < SensitivityType > | property_button_sensitivity () const
| Whether the dropdown button is sensitive when the model is empty.
Glib::PropertyProxy< bool > | property_popup_fixed_width ()
| Whether the popup's width should be a fixed width matching the allocated width of the combo box.
Glib::PropertyProxy_ReadOnly < bool > | property_popup_fixed_width () const
| Whether the popup's width should be a fixed width matching the allocated width of the combo box.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< CellArea > > | property_cell_area () const
| The GtkCellArea used to layout cells.
Glib::PropertyProxy_ReadOnly < bool > | property_has_entry () const
| Whether combo box has an entry.
Glib::PropertyProxy< int > | property_entry_text_column ()
| The column in the combo box's model to associate with strings from the entry if the combo was created with #GtkComboBox:has-entry = TRUE.
Glib::PropertyProxy_ReadOnly< int > | property_entry_text_column () const
| The column in the combo box's model to associate with strings from the entry if the combo was created with #GtkComboBox:has-entry = TRUE.
Glib::PropertyProxy< int > | property_id_column ()
| The column in the combo box's model that provides string IDs for the values in the model.
Glib::PropertyProxy_ReadOnly< int > | property_id_column () const
| The column in the combo box's model that provides string IDs for the values in the model.
Glib::PropertyProxy < Glib::ustring > | property_active_id ()
| The value of the id column for the active row.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_active_id () const
| The value of the id column for the active row.
Glib::SignalProxy0< void > | signal_changed ()
Glib::SignalProxy1 < Glib::ustring, const TreeModel::Path& > | signal_format_entry_text ()
Public Member Functions inherited from Gtk::Bin
virtual | ~Bin ()
Gtk::Widget* | get_child ()
| Gets the child of the Gtk::Bin, or `0` if the bin contains no child widget.
const Gtk::Widget* | get_child () const
| Gets the child of the Gtk::Bin, or `0` if the bin contains no child widget.
void | remove ()
| Remove the contained object Since this can only hold one object it is not necessary to specify which object to remove like other containers.
void | add_label (const Glib::ustring& label, bool mnemonic=false, double x_align=0.5, double y_align=0.5)
| Add a Label object.
void | add_label (const Glib::ustring& label, bool mnemonic, Align x_align, Align y_align=ALIGN_CENTER)
| Add a Label object.
void | add_pixlabel (const std::string& pixfile, const Glib::ustring& label, double x_align=0.5, double y_align=0.5)
| Add Image and Label objects.
Public Member Functions inherited from Gtk::Container
virtual | ~Container ()
void | set_border_width (guint border_width)
| Sets the border width of the container.
guint | get_border_width () const
| Retrieves the border width of the container.
virtual void | add (Widget& widget)
void | remove (Widget& widget)
| Removes widget from container.
void | set_resize_mode (ResizeMode resize_mode)
| Sets the resize mode for the container.
ResizeMode | get_resize_mode () const
| Returns the resize mode for the container.
void | check_resize ()
| Request that contained widgets check their size.
void | foreach (const ForeachSlot& slot)
| Operate on contained items.
void | forall (const ForeachSlot& slot)
| Operate on contained items, including internal children.
std::vector< Widget* > | get_children ()
| (internal) Operate on contained items (see foreach())
std::vector< const Widget* > | get_children () const
| Returns the container's non-internal children.
void | propagate_draw (Widget& child, const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| When a container receives a call to the draw function, it must send synthetic Gtk::Widget::signal_draw() calls to all children that don't have their own Gdk::Windows.
void | set_focus_chain (const std::vector< Widget* >& focusable_widgets)
| Sets a focus chain, overriding the one computed automatically by GTK+.
bool | has_focus_chain () const
std::vector< Widget* > | get_focus_chain ()
std::vector< const Widget* > | get_focus_chain () const
void | unset_focus_chain ()
| Removes a focus chain explicitly set with set_focus_chain().
void | set_reallocate_redraws (bool needs_redraws=true)
| Sets the reallocate_redraws flag of the container to the given value.
void | set_focus_child (Widget& widget)
| Sets the focus on a child.
Widget* | get_focus_child ()
| Returns the current focus child widget inside container.
const Widget* | get_focus_child () const
| Returns the current focus child widget inside container.
void | set_focus_vadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget.
Glib::RefPtr< Adjustment > | get_focus_vadjustment ()
| Retrieves the vertical focus adjustment for the container.
Glib::RefPtr< const Adjustment > | get_focus_vadjustment () const
| Retrieves the vertical focus adjustment for the container.
void | set_focus_hadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget.
Glib::RefPtr< Adjustment > | get_focus_hadjustment ()
| Retrieves the horizontal focus adjustment for the container.
Glib::RefPtr< const Adjustment > | get_focus_hadjustment () const
| Retrieves the horizontal focus adjustment for the container.
void | resize_children ()
GType | child_type () const
| Returns the type of the children supported by the container.
WidgetPath | get_path_for_child (const Widget& child) const
| Returns a newly created widget path representing all the widget hierarchy from the toplevel down to and including child.
Glib::SignalProxy1< void, Widget* > | signal_add ()
Glib::SignalProxy1< void, Widget* > | signal_remove ()
Glib::SignalProxy0< void > | signal_check_resize ()
Glib::SignalProxy1< void, Widget* > | signal_set_focus_child ()
void | show_all_children (bool recursive=true)
Public Member Functions inherited from Gtk::Widget
virtual | ~Widget ()
| Destroys the widget.
void | show ()
| Flags a widget to be displayed.
void | show_now ()
| Shows a widget.
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user).
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container).
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget.
void | queue_draw_area (int x, int y, int width, int height)
| Convenience function that calls queue_draw_region() on the region created from the given coordinates.
void | queue_draw_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Invalidates the rectangular area of widget defined by region by calling gdk_window_invalidate_region() on the widget's window and all its child windows.
void | queue_resize ()
| This function is only for use in widget implementations.
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | get_preferred_width (int& minimum_width, int& natural_width) const
| Retrieves a widget's initial minimum and natural width.
void | get_preferred_height_for_width (int width, int& minimum_height, int& natural_height) const
| Retrieves a widget's minimum and natural height if it would be given the specified width.
void | get_preferred_height (int& minimum_height, int& natural_height) const
| Retrieves a widget's initial minimum and natural height.
void | get_preferred_width_for_height (int height, int& minimum_width, int& natural_width) const
| Retrieves a widget's minimum and natural width if it would be given the specified height.
void | get_preferred_size (Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget's preference for height-for-width management.
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated.
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator().
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated.
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal.
bool | event (GdkEvent* event)
| Rarely-used function.
int | send_expose (GdkEvent*event)
| Very rarely-used function.
bool | send_focus_change (GdkEvent*event)
| Sends the focus change event to widget.
bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.) this function activates them.
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget.
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection.
::Cairo::RefPtr< ::Cairo::Region > | region_intersect (const ::Cairo::RefPtr< ::Cairo::Region >& region) const
| Computes the intersection of a widget's area and region, returning the intersection.
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget.
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget.
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify().
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus.
bool | get_can_focus () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside.
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget.
bool | get_can_default () const
| Determines whether widget can be a default widget.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | grab_default ()
| Causes widget to become the default widget.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default.
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse).
bool | device_is_shadowed (const Glib::RefPtr< const Gdk::Device >& device)
| Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget.
void | add_modal_grab ()
| Block events to everything else than this widget and its children.
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed.
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a CSS file.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state (StateType state)
| This function is for use in widget implementations.
StateType | get_state () const
| Returns the widget's state.
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations.
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()).
bool | is_sensitive () const
| Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own.
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget.
bool | get_is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering.
bool | get_double_buffered () const
| Determines whether the widget is double buffered.
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes.
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show().
bool | get_child_visible () const
| Gets the value set with set_child_visible().
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget's window if it is realized, `0` otherwise.
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget's window if it is realized, `0` otherwise.
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
Allocation | get_allocation () const
| Retrieves the widget's location.
void | set_allocation (const Allocation& allocation)
| Sets the widget's allocation.
Container* | get_parent ()
| Returns the parent container of widget.
const Container* | get_parent () const
| Returns the parent container of widget.
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget's parent window.
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget's parent window.
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget.
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order.
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be width by height.
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget.
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget.
void | set_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Sets the device event mask (see Gdk::EventMask) for a widget.
void | add_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Adds the device events in the bitfield events to the event mask for widget.
void | set_device_enabled (const Glib::RefPtr< Gdk::Device >& device, bool enabled=true)
| Enables or disables a Gdk::Device to interact with widget and all its children.
bool | get_device_enabled (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns whether device can interact with widget and its children.
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of.
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of.
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget.
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget.
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located.
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget.
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used.
void | queue_compute_expand ()
| Mark widget as needing to recompute its expand flags.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
bool | get_support_multidevice () const
| Returns `true` if widget is multiple pointer aware.
void | set_support_multidevice (bool support_multidevice=true)
| Enables or disables multiple pointer awareness.
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology.
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology.
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_left () const
| Gets the value of the Gtk::Widget::property_margin_left() property.
void | set_margin_left (int margin)
| Sets the left margin of widget.
int | get_margin_right () const
| Gets the value of the Gtk::Widget::property_margin_right() property.
void | set_margin_right (int margin)
| Sets the right margin of widget.
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
Gdk::EventMask | get_events () const
| Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration).
Gdk::EventMask | get_device_events (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns the events mask for the widget corresponding to an specific device.
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates.
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations.
void | override_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_color (StateFlags state=(StateFlags) 0)
void | override_background_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_background_color (StateFlags state=(StateFlags) 0)
void | override_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget.
void | unset_font ()
void | override_symbolic_color (const Glib::ustring& name, const Gdk::RGBA& color)
| Sets a symbolic color for a widget.
void | unset_symbolic_color (const Glib::ustring& name)
void | override_cursor (const Gdk::RGBA& cursor, const Gdk::RGBA& secondary_cursor)
| Sets the cursor color to use in a widget, overriding the Gtk::Widget::property_cursor_color() and Gtk::Widget::property_secondary_cursor_color() style properties.
void | unset_cursor ()
void | reset_style ()
| Updates the style context of widget and all descendents by updating its widget path.
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType& value) const
| Gets the value of a style property of widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Gdk::Pixbuf > | render_icon_pixbuf (const StockID& stock_id, IconSize size)
| A convenience function that uses the theme engine and style settings for widget to look up stock_id and render it to a pixbuf.
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name.
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets a shape for this widget's GDK window.
void | input_shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets an input shape for this widget's GDK window.
WidgetPath | get_path () const
| Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created.
std::vector< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
std::vector< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget.
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
void | drag_highlight ()
void | drag_unhighlight ()
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const std::vector< TargetEntry >& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
void | drag_dest_unset ()
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE.
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
void | drag_dest_add_text_targets ()
void | drag_dest_add_image_targets ()
void | drag_dest_add_uri_targets ()
void | drag_source_set (const std::vector< TargetEntry >& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon.
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon.
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_add_uri_targets ()
void | drag_source_add_image_targets ()
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent*event)
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated.
bool | get_no_show_all () const
| Returns the current value of the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container.
void | unparent ()
| This function is only for use in widget implementations.
void | map ()
| This function is only for use in widget implementations.
void | unmap ()
| This function is only for use in widget implementations.
void | draw_insertion_cursor (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
| Draws a text caret on cr at location.
void | set_tooltip_window (Window& widget)
| Replaces the default, usually yellow, window used for displaying tooltips with custom_window.
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< Gtk::StyleContext > | get_style_context () const
| Returns the style context associated to widget.
Gdk::ModifierType | get_modifier_mask (Gdk::ModifierIntent intent)
| Returns the modifier mask the widget's windowing system backend uses for a particular purpose.
Glib::SignalProxy0< void > | signal_show ()
Glib::SignalProxy0< void > | signal_hide ()
Glib::SignalProxy0< void > | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy0< void > | signal_unmap ()
Glib::SignalProxy0< void > | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy0< void > | signal_unrealize ()
Glib::SignalProxy1< void, Allocation& > | signal_size_allocate ()
Glib::SignalProxy1< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy1< void, Gtk::StateFlags > | signal_state_flags_changed ()
Glib::SignalProxy1< void, Widget* > | signal_parent_changed ()
| Informs objects that their parent changed.
Glib::SignalProxy1< void, Widget* > | signal_hierarchy_changed ()
Glib::SignalProxy0< void > | signal_style_updated ()
Glib::SignalProxy1< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy1< void, bool > | signal_grab_notify ()
Glib::SignalProxy1< void, GParamSpec* > | signal_child_notify ()
Glib::SignalProxy1< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy0< void > | signal_grab_focus ()
Glib::SignalProxy1< bool, DirectionType > | signal_focus ()
Glib::SignalProxy1< bool, GdkEvent* > | signal_event ()
Glib::SignalProxy1< void, GdkEvent* > | signal_event_after ()
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_press_event ()
| Event triggered by user pressing button.
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_release_event ()
| Event triggered by user releasing button.
Glib::SignalProxy1< bool, GdkEventScroll* > | signal_scroll_event ()
Glib::SignalProxy1< bool, GdkEventMotion* > | signal_motion_notify_event ()
| Event triggered by user moving pointer.
Glib::SignalProxy1< bool, GdkEventAny* > | signal_delete_event ()
Glib::SignalProxy1< bool, const ::Cairo::RefPtr < ::Cairo::Context >& > | signal_draw ()
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_press_event ()
| Event triggered by a key press will widget has focus.
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_release_event ()
| Event triggered by a key release will widget has focus.
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_enter_notify_event ()
| Event triggered by pointer entering widget area.
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area.
Glib::SignalProxy1< bool, GdkEventConfigure* > | signal_configure_event ()
| Event triggered by a window resizing.
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_in_event ()
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_out_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_map_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_unmap_event ()
Glib::SignalProxy1< bool, GdkEventProperty* > | signal_property_notify_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_clear_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_request_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_notify_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_in_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_out_event ()
Glib::SignalProxy1< bool, GdkEventVisibility* > | signal_visibility_notify_event ()
Glib::SignalProxy1< bool, GdkEventWindowState* > | signal_window_state_event ()
Glib::SignalProxy3< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy2< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_begin ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_end ()
Glib::SignalProxy4< void, const Glib::RefPtr < Gdk::DragContext > &, SelectionData&, guint, guint > | signal_drag_data_get ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_data_delete ()
Glib::SignalProxy2< bool, const Glib::RefPtr < Gdk::DragContext > &, DragResult > | signal_drag_failed ()
Glib::SignalProxy2< void, const Glib::RefPtr < Gdk::DragContext >&, guint > | signal_drag_leave ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
Glib::SignalProxy6< void, const Glib::RefPtr < Gdk::DragContext >&, int, int, const SelectionData &, guint, guint > | signal_drag_data_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::Screen >& > | signal_screen_changed ()
Glib::SignalProxy0< void > | signal_composited_changed ()
Glib::SignalProxy0< bool > | signal_popup_menu ()
Glib::SignalProxy4< bool, int, int, bool, const Glib::RefPtr < Tooltip >& > | signal_query_tooltip ()
Glib::SignalProxy1< bool, GdkEventGrabBroken* > | signal_grab_broken_event ()
Glib::SignalProxy1< bool, GdkEventExpose* > | signal_damage_event ()
Glib::SignalProxy1< bool, GdkEventTouch* > | signal_touch_event ()
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy< Container* > | property_parent ()
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly < Container* > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly < bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly < bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget.
Glib::PropertyProxy_ReadOnly < bool > | property_app_paintable () const
| Whether the application will paint directly on the widget.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus.
Glib::PropertyProxy_ReadOnly < bool > | property_can_focus () const
| Whether the widget can accept the input focus.
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus.
Glib::PropertyProxy_ReadOnly < bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy_ReadOnly < bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget.
Glib::PropertyProxy_ReadOnly < bool > | property_can_default () const
| Whether the widget can be the default widget.
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget.
Glib::PropertyProxy_ReadOnly < bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| If TRUE, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly < bool > | property_receives_default () const
| If TRUE, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly < bool > | property_composite_child () const
| Whether the widget is part of a composite widget.
Glib::PropertyProxy < Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors etc).
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors etc).
Glib::PropertyProxy < Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy_ReadOnly < Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Whether this widget has a tooltip.
Glib::PropertyProxy_ReadOnly < bool > | property_has_tooltip () const
| Whether this widget has a tooltip.
Glib::PropertyProxy < Glib::ustring > | property_tooltip_markup ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_markup () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy < Glib::ustring > | property_tooltip_text ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_text () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized.
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether gtk_widget_show_all() should not affect this widget.
Glib::PropertyProxy_ReadOnly < bool > | property_no_show_all () const
| Whether gtk_widget_show_all() should not affect this widget.
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether the widget is double buffered.
Glib::PropertyProxy_ReadOnly < bool > | property_double_buffered () const
| Whether the widget is double buffered.
Glib::PropertyProxy< Align > | property_halign ()
| How to position in extra horizontal space.
Glib::PropertyProxy_ReadOnly < Align > | property_halign () const
| How to position in extra horizontal space.
Glib::PropertyProxy< Align > | property_valign ()
| How to position in extra vertical space.
Glib::PropertyProxy_ReadOnly < Align > | property_valign () const
| How to position in extra vertical space.
Glib::PropertyProxy< int > | property_margin_left ()
| Pixels of extra space on the left side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_left () const
| Pixels of extra space on the left side.
Glib::PropertyProxy< int > | property_margin_right ()
| Pixels of extra space on the right side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_right () const
| Pixels of extra space on the right side.
Glib::PropertyProxy< int > | property_margin_top ()
| Pixels of extra space on the top side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Pixels of extra space on the top side.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Pixels of extra space on the bottom side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Pixels of extra space on the bottom side.
Glib::PropertyProxy< int > | property_margin ()
| Pixels of extra space on all four sides.
Glib::PropertyProxy_ReadOnly< int > | property_margin () const
| Pixels of extra space on all four sides.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether widget wants more horizontal space.
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand () const
| Whether widget wants more horizontal space.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property.
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand_set () const
| Whether to use the hexpand property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether widget wants more vertical space.
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand () const
| Whether widget wants more vertical space.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property.
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand_set () const
| Whether to use the vexpand property.
Glib::PropertyProxy< bool > | property_expand ()
| Whether widget wants to expand in both directions.
Glib::PropertyProxy_ReadOnly < bool > | property_expand () const
| Whether widget wants to expand in both directions.
Public Member Functions inherited from Gtk::Object
virtual | ~Object ()
Public Member Functions inherited from Glib::Object
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj_copy () const
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Gtk::Buildable
virtual | ~Buildable ()
Public Member Functions inherited from Glib::Interface
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
virtual | ~Interface ()
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj_copy () const
Public Member Functions inherited from Gtk::CellLayout
virtual | ~CellLayout ()
template<class ColumnType >
void | pack_start (const TreeModelColumn< ColumnType >& model_column, bool expand=true)
void | pack_start (CellRenderer& cell, bool expand=true)
| Packs the cell into the beginning of cell_layout.
void | pack_end (CellRenderer& cell, bool expand=true)
| Adds the cell to the end of cell_layout.
std::vector< CellRenderer* > | get_cells ()
| Return value: a list of cell renderers.
std::vector< const CellRenderer* > | get_cells () const
| Return value: a list of cell renderers.
CellRenderer* | get_first_cell ()
| Gets the CellRenderer for the column.
const CellRenderer* | get_first_cell () const
| Gets the CellRenderer for the column.
void | clear ()
| Unsets all the mappings on all renderers on cell_layout and removes all renderers from cell_layout.
void | add_attribute (CellRenderer& cell, const Glib::ustring& attribute, int column)
| Adds an attribute mapping to the list in cell_layout.
void | add_attribute (const Glib::PropertyProxy_Base& property, const TreeModelColumnBase& column)
void | add_attribute (CellRenderer& cell, const Glib::ustring& attribute, const TreeModelColumnBase& column)
void | set_cell_data_func (CellRenderer& cell, const SlotCellData& slot)
void | clear_attributes (CellRenderer& cell)
| Clears all existing attributes previously set with set_attributes().
void | reorder (CellRenderer& cell, int position)
| Re-inserts cell at position.
Glib::RefPtr< CellArea > | get_area ()
| Returns the underlying Gtk::CellArea which might be cell_layout if called on a Gtk::CellArea or might be `0` if no Gtk::CellArea is used by cell_layout.
Glib::RefPtr< const CellArea > | get_area () const
| Returns the underlying Gtk::CellArea which might be cell_layout if called on a Gtk::CellArea or might be `0` if no Gtk::CellArea is used by cell_layout.
template<class T_ModelColumnType >
void | pack_start (const TreeModelColumn< T_ModelColumnType >& column, bool expand)
Public Member Functions inherited from Gtk::CellEditable
virtual | ~CellEditable ()
void | start_editing (GdkEvent* event)
| Begins editing on a cell_editable.
void | editing_done ()
| Emits the Gtk::CellEditable::signal_editing_done() signal.
void | remove_widget ()
| Emits the Gtk::CellEditable::signal_remove_widget() signal.
Glib::SignalProxy0< void > | signal_editing_done ()
Glib::SignalProxy0< void > | signal_remove_widget ()
Glib::PropertyProxy< bool > | property_editing_canceled ()
| Indicates that editing has been canceled.
Glib::PropertyProxy_ReadOnly < bool > | property_editing_canceled () const
| Indicates that editing has been canceled.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Functions
(Note that these are not member functions.)
Gtk::ComboBoxText* | wrap (GtkComboBoxText* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::ComboBox
Gtk::ComboBox* | wrap (GtkComboBox* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Bin
Gtk::Bin* | wrap (GtkBin* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Container
Gtk::Container* | wrap (GtkContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::CellLayout
Glib::RefPtr< Gtk::CellLayout > | wrap (GtkCellLayout* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::CellEditable
Glib::RefPtr< Gtk::CellEditable > | wrap (GtkCellEditable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gtk::ComboBox
typedef TreeView::SlotRowSeparator | SlotRowSeparator
Public Types inherited from Gtk::CellLayout
typedef sigc::slot< void, const TreeModel::const_iterator& > | SlotCellData
Protected Member Functions inherited from Gtk::ComboBox
virtual void | on_changed ()
| This is a default handler for the signal signal_changed().
Protected Member Functions inherited from Gtk::Bin
| Bin ()
| This constructor is protected because only derived classes should be instantiated.
Protected Member Functions inherited from Gtk::Container
virtual void | on_add (Widget* widget)
| This is a default handler for the signal signal_add().
virtual void | on_remove (Widget* widget)
| This is a default handler for the signal signal_remove().
virtual void | on_check_resize ()
| This is a default handler for the signal signal_check_resize().
virtual void | on_set_focus_child (Widget* widget)
| This is a default handler for the signal signal_set_focus_child().
| Container ()
virtual GType | child_type_vfunc () const
| Implements child_type().
virtual void | forall_vfunc (gboolean include_internals, GtkCallback callback, gpointer callback_data)
| Invokes a callback on all children of the container.
virtual char* | composite_name_vfunc (GtkWidget* child)
| Returns the composite name of a child widget.
virtual void | set_child_property_vfunc (GtkWidget* child, guint property_id, const GValue* value, GParamSpec* pspec)
| Sets a child property for this container and its child.
virtual void | get_child_property_vfunc (GtkWidget* child, guint property_id, GValue* value, GParamSpec* pspec) const
| Returns a child property for this container and its child.
Glib::PropertyProxy< guint > | property_border_width ()
| The width of the empty border outside the containers children.
Glib::PropertyProxy_ReadOnly < guint > | property_border_width () const
| The width of the empty border outside the containers children.
Glib::PropertyProxy< ResizeMode > | property_resize_mode ()
| Specify how resize events are handled.
Glib::PropertyProxy_ReadOnly < ResizeMode > | property_resize_mode () const
| Specify how resize events are handled.
Glib::PropertyProxy_WriteOnly < Widget* > | property_child ()
| Can be used to add a new child to the container.
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate().
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed().
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed().
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed().
virtual void | on_style_updated ()
| This is a default handler for the signal signal_style_updated().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify().
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus().
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus().
virtual bool | on_event (GdkEvent*event)
| This is a default handler for the signal signal_event().
virtual bool | on_button_press_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_press_event().
virtual bool | on_button_release_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_release_event().
virtual bool | on_scroll_event (GdkEventScroll*event)
| This is a default handler for the signal signal_scroll_event().
virtual bool | on_motion_notify_event (GdkEventMotion*event)
| This is a default handler for the signal signal_motion_notify_event().
virtual bool | on_delete_event (GdkEventAny*event)
| This is a default handler for the signal signal_delete_event().
virtual bool | on_draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| This is a default handler for the signal signal_draw().
virtual bool | on_key_press_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_press_event().
virtual bool | on_key_release_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_release_event().
virtual bool | on_enter_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_enter_notify_event().
virtual bool | on_leave_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_leave_notify_event().
virtual bool | on_configure_event (GdkEventConfigure*event)
| This is a default handler for the signal signal_configure_event().
virtual bool | on_focus_in_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_in_event().
virtual bool | on_focus_out_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_out_event().
virtual bool | on_map_event (GdkEventAny*event)
| This is a default handler for the signal signal_map_event().
virtual bool | on_unmap_event (GdkEventAny*event)
| This is a default handler for the signal signal_unmap_event().
virtual bool | on_property_notify_event (GdkEventProperty*event)
| This is a default handler for the signal signal_property_notify_event().
virtual bool | on_selection_clear_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_clear_event().
virtual bool | on_selection_request_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_request_event().
virtual bool | on_selection_notify_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_notify_event().
virtual bool | on_proximity_in_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_in_event().
virtual bool | on_proximity_out_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_out_event().
virtual bool | on_visibility_notify_event (GdkEventVisibility*event)
| This is a default handler for the signal signal_visibility_notify_event().
virtual bool | on_window_state_event (GdkEventWindowState*event)
| This is a default handler for the signal signal_window_state_event().
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get().
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received().
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin().
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end().
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get().
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete().
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave().
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion().
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop().
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received().
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed().
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (int& minimum_width, int& natural_width) const
virtual void | get_preferred_height_for_width_vfunc (int width, int& minimum_height, int& natural_height) const
virtual void | get_preferred_height_vfunc (int& minimum_height, int& natural_height) const
virtual void | get_preferred_width_for_height_vfunc (int height, int& minimum_width, int& natural_width) const
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget.
void | unrealize ()
| This function is only useful in widget implementations.
void | draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| Draws widget to cr.
void | set_mapped (bool mapped=true)
| Marks the widget as being realized.
void | set_realized (bool realized=true)
| Marks the widget as being realized.
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own.
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window.
void | transform_cairo_context_to_window (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| Transforms the given cairo context cr from widget-relative coordinates to window-relative coordinates.
Requisition | get_requisition () const
| Retrieves the widget's requisition.
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase& value) const
| Gets the value of a style property of widget.
void | realize_if_needed ()
void | insert_action_group (const Glib::ustring& name, const Glib::RefPtr< Gio::ActionGroup >& group)
| Inserts group into widget.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Glib::Interface
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
virtual | ~ObjectBase ()=0
void | initialize (GObject *castitem)
Protected Member Functions inherited from Gtk::CellLayout
| CellLayout ()
| You should derive from this class to use it.
virtual void | pack_start_vfunc (CellRenderer* cell, bool expand)
virtual void | pack_end_vfunc (CellRenderer* cell, bool expand)
virtual void | clear_vfunc ()
virtual void | add_attribute_vfunc (CellRenderer* cell, const Glib::ustring& attribute, int column)
virtual void | clear_attributes_vfunc (CellRenderer* cell)
virtual void | reorder_vfunc (CellRenderer* cell, int position)
Protected Member Functions inherited from Gtk::CellEditable
| CellEditable ()
| You should derive from this class to use it.
virtual void | start_editing_vfunc (GdkEvent* event)
virtual void | on_editing_done ()
| This is a default handler for the signal signal_editing_done().
virtual void | on_remove_widget ()
| This is a default handler for the signal signal_remove_widget().

## Detailed Description

This is a simple variant of ComboBox that hides the model-view complexity for simple text-only use cases.

You can add items to a ComboBoxText with append(), insert() or prepend() and remove items with remove_text().

If the ComboBoxText contains an entry (via the 'has_entry' property), its contents can be retrieved using get_active_text(). The entry itself can be accessed by calling ComboBox::get_entry() or ComboBox::get_entry_text().

You should not call set_model() or attempt to pack more cells into this combo box via its CellLayout base class.

## Constructor & Destructor Documentation

virtual Gtk::ComboBoxText::~ComboBoxText | ( |  | ) |
| virtual

Gtk::ComboBoxText::ComboBoxText | ( | bool | has_entry = `false` | ) |
| explicit

Creates a new empty ComboBoxText, optionally with an entry.

Parameters:

  has_entry | If this is true then this will have an Entry widget.

## Member Function Documentation

void Gtk::ComboBoxText::append | ( | const Glib::ustring & | text | ) |

Appends text to the list of strings stored in combo_box.

This is the same as calling insert_text() with a position of -1.

Since gtkmm 2.24:

Parameters:

  text | A string.

void Gtk::ComboBoxText::append | ( | const Glib::ustring & | id,
|  | const Glib::ustring & | text
| ) |  |

Appends text to the list of strings stored in combo_box.

If id is non-`0` then it is used as the ID of the row.

This is the same as calling insert() with a position of -1.

Since gtkmm 2.24:

Parameters:

  id | A string ID for this value, or `0`.
  text | A string.

Glib::ustring Gtk::ComboBoxText::get_active_text | ( |  | ) | const

Returns the currently active string in combo_box, or `0` if none is selected.

If combo_box contains an entry, this function will return its contents (which will not necessarily be an item from the list).

Since gtkmm 2.24:

Returns:
  A newly allocated string containing the currently active text. Must be freed with Glib::free().

static GType Gtk::ComboBoxText::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Reimplemented from Gtk::ComboBox.

GtkComboBoxText* Gtk::ComboBoxText::gobj | ( |  | ) |
| inline

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::ComboBox.

const GtkComboBoxText* Gtk::ComboBoxText::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::ComboBox.

void Gtk::ComboBoxText::insert | ( | int | position,
|  | const Glib::ustring & | text
| ) |  |

Inserts text at position in the list of strings stored in combo_box.

If position is negative then text is appended.

This is the same as calling insert() with a `0` ID string.

Since gtkmm 2.24:

Parameters:

  position | An index to insert text.
  text | A string.

void Gtk::ComboBoxText::insert | ( | int | position,
|  | const Glib::ustring & | id,
|  | const Glib::ustring & | text
| ) |  |

Inserts text at position in the list of strings stored in combo_box.

If id is non-`0` then it is used as the ID of the row. See Gtk::ComboBox::property_id_column().

If position is negative then text is appended.

Since gtkmm 3.0:

Parameters:

  position | An index to insert text.
  id | A string ID for this value, or `0`.
  text | A string to display.

void Gtk::ComboBoxText::prepend | ( | const Glib::ustring & | text | ) |

Prepends text to the list of strings stored in combo_box.

This is the same as calling insert_text() with a position of 0.

Since gtkmm 2.24:

Parameters:

  text | A string.

void Gtk::ComboBoxText::prepend | ( | const Glib::ustring & | id,
|  | const Glib::ustring & | text
| ) |  |

Prepends text to the list of strings stored in combo_box.

If id is non-`0` then it is used as the ID of the row.

This is the same as calling insert() with a position of 0.

Since gtkmm 2.24:

Parameters:

  id | A string ID for this value, or `0`.
  text | A string.

void Gtk::ComboBoxText::remove_all | ( |  | ) |

Removes all the text entries from the combo box.

Since gtkmm 3.0:

void Gtk::ComboBoxText::remove_text | ( | int | position | ) |

Removes the string at position from combo_box.

Since gtkmm 2.24:

Parameters:

  position | Index of the item to remove.

void Gtk::ComboBoxText::set_active_text | ( | const Glib::ustring & | text | ) |

## Friends And Related Function Documentation

Gtk::ComboBoxText* wrap | ( | GtkComboBoxText * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/comboboxtext.h